
Auto Multiple Choice - Bug # 700: Changed students codes are not updated

Status: Closed Priority: Normal
Author: Florent Bouchez Tichadou Category:
Created: 01/27/2020 Assignee:
Updated: 12/21/2020 Due date:
Description: Students often make a mistake when encoding their (anonymous) number for the exam.

When I try to manually correct the codes, AMC still "remembers" the old version and just concatenates (and 
mixes) numbers.
For instance a wrong number was :
11246049
which I corrected into :
19001801

However, AMC now thinks the number is :
119080112460649

(I even tried modifying it in the scoring_code database but with no luck :-().

History
01/27/2020 02:30 pm - Florent Bouchez Tichadou
Found the problem : the sql statement checks for manual OR filled box, so does not check if box has been un-checked.

Here is a patch:

--- capture.pm.orig	2020-01-27 14:18:43.788834212 +0100
+++ capture.pm.fix	2020-01-27 14:28:08.780817693 +0100
@@ -587,7 +587,8 @@
 		   ." ORDER BY id_b"},
      'tickedChars'=>{sql=>"SELECT char FROM (SELECT id_b FROM $t_zone"
                      ."       WHERE student=? AND copy=? AND id_a=? AND type=?"
-                     ."       AND (manual=1 OR (black >= ? * total AND black <= ? * total))"
+                     ."       AND (manual = 1"
+                     ."            OR manual < 0 AND (black >= ? * total AND black <= ? * total))"
                      ." ),( SELECT answer,char FROM ".$self->table("box","layout")
                      ."       WHERE student=? AND question=? AND role=?)"
                      ." ON id_b=answer ORDER BY id_b"

01/27/2020 02:31 pm - Florent Bouchez Tichadou
(Update with "pre" format)

<pre>
--- capture.pm.orig	2020-01-27 14:18:43.788834212 +0100
+++ capture.pm.fix	2020-01-27 14:28:08.780817693 +0100
@@ -587,7 +587,8 @@
 		   ." ORDER BY id_b"},
      'tickedChars'=>{sql=>"SELECT char FROM (SELECT id_b FROM $t_zone"
                      ."       WHERE student=? AND copy=? AND id_a=? AND type=?"
-                     ."       AND (manual=1 OR (black >= ? * total AND black <= ? * total))"
+                     ."       AND (manual = 1"
+                     ."            OR manual < 0 AND (black >= ? * total AND black <= ? * total))"
                      ." ),( SELECT answer,char FROM ".$self->table("box","layout")
                      ."       WHERE student=? AND question=? AND role=?)"
                      ." ON id_b=answer ORDER BY id_b"
</pre>

12/21/2020 12:35 pm - Alexis Bienvenüe
- Status changed from New to Closed

- Target version set to 1.5.0

- % Done changed from 0 to 100

Thanks very much for this bug report and investigation, and sorry for being so late. git:f871f1a6ccc70
